package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.DistribuicaodaRefeicaoPage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class DistribuicaodaRefeicaoTest extends TestBase {
    //Object

    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    DistribuicaodaRefeicaoPage distribuicaodarefeicaopage;


    //Tests
    @Test
    public void DistribuicaoManual() throws InterruptedException {
        //Objects Instances
        mainPage = new MainPage();

        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        distribuicaodarefeicaopage = new DistribuicaodaRefeicaoPage();

        // Parameters codigo =
        String usuario = "francielly.automacao";
        String senha = "2022Teknisa";
        String descricao = "Teste automatizado";
        String datainicio = "01092022";
        String datafim = "12092022";
        String msgesperada = "Efetivação realizada com sucesso.";


        loginFlows.efetuarLogin(usuario, senha);
        distribuicaodarefeicaopage.AcessarTela();

        // Teste
        distribuicaodarefeicaopage.DistribuicaoManual(descricao,datainicio,datafim);
        distribuicaodarefeicaopage.efetivardistribuicao();

        String statusatual = distribuicaodarefeicaopage.efetivacaorealiz();

        Assert.assertEquals(statusatual,msgesperada);

        distribuicaodarefeicaopage.Okefetivacaoconcluida();
    }


    //Teste 2 - Gerar nova distribuição
    @Test
    public void GerarNovaDistribuicao() throws InterruptedException {
        //Objects Instances
        mainPage = new MainPage();

        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        distribuicaodarefeicaopage = new DistribuicaodaRefeicaoPage();

        // Parameters codigo =
        String usuario = "francielly.automacao";
        String senha = "2022Teknisa";
        String dataini = "26092022";
        String dataf = "26092022";
        String msgesperada = "Efetivação realizada com sucesso.";

        loginFlows.efetuarLogin(usuario, senha);
        distribuicaodarefeicaopage.AcessarTela();

        // Teste
        distribuicaodarefeicaopage.NovaDistribuicao(dataini,dataf);
        distribuicaodarefeicaopage.efetivardistribuicao();

        String statusatual = distribuicaodarefeicaopage.efetivacaorealiz();

        Assert.assertEquals(statusatual,msgesperada);

        distribuicaodarefeicaopage.Okefetivacaoconcluida();
    }


    // TESTE 03 - Distribuição Manual, Adicionar mais itens para serem distribuidos e calcular embalagem
    @Test
    public void AdicionarmaisitenseCalcularEmbalagem() throws InterruptedException {
        //Objects Instances
        mainPage = new MainPage();

        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        distribuicaodarefeicaopage = new DistribuicaodaRefeicaoPage();

        // Parameters codigo =
        String usuario = "francielly.automacao";
        String senha = "2022Teknisa";
        String descricao = "Teste automatizado";
        String dataini = "23082022";
        String dataf = "30082022";

        loginFlows.efetuarLogin(usuario, senha);
        distribuicaodarefeicaopage.AcessarTela();

        // Teste
        distribuicaodarefeicaopage.DistribuicaoManual(descricao, dataini, dataf);
        distribuicaodarefeicaopage.Adicionarproduto();
        distribuicaodarefeicaopage.CalcularEmbalagem();
    }

    // TESTE 04 - Selecionando distribuição e navegando pelas ações
    @Test
    public void SelecionarDistribuicaoeNavegarAcoes() throws InterruptedException {
        //Objects Instances
        mainPage = new MainPage();

        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        distribuicaodarefeicaopage = new DistribuicaodaRefeicaoPage();

        // Parameters codigo =
        String usuario = "francielly.automacao";
        String senha = "2022Teknisa";
        String comensais = "20";
        String quantidadepessoa = "2";
        String quantidadedoprato = "30";
        String agroupunidade = "1";
        String msgesperada = "Efetivação realizada com sucesso.";


        loginFlows.efetuarLogin(usuario, senha);
        distribuicaodarefeicaopage.AcessarTela();

        // Teste
        distribuicaodarefeicaopage.SelecionarDistribuicao();
        distribuicaodarefeicaopage.NavegarPelasAcoes(comensais, quantidadepessoa, quantidadedoprato, agroupunidade);
        distribuicaodarefeicaopage.CalcularEmbalagem();

        String statusatual = distribuicaodarefeicaopage.efetivacaorealiz();
        Assert.assertEquals(statusatual,msgesperada);

        distribuicaodarefeicaopage.Okefetivacaoconcluida();
    }

}
