package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.GeracaodeProdutoAcabadoPage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class GeraçãodeProdutoAcabadoTest extends TestBase {
    //Object

    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    GeracaodeProdutoAcabadoPage geracaodeprodutoacabadopage;


    //Tests
    @Test
    public void GerarProdutoAcabado () throws InterruptedException {
        //Objects Instances
        mainPage = new MainPage();

        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        geracaodeprodutoacabadopage = new GeracaodeProdutoAcabadoPage();


        // Parameters codigo =

        String usuario = "francielly.automacao";
        String senha = "Teknisa2022";
        String msgesperada = "Processo realizado com sucesso!";

        loginFlows.efetuarLogin(usuario,senha);
        geracaodeprodutoacabadopage.AcessarTela();

        // Teste
        geracaodeprodutoacabadopage.selecionarplanejamento();
        geracaodeprodutoacabadopage.gerarplanejamento();

        String statusatual = geracaodeprodutoacabadopage.geracaoprodutoacabadoconcluida();
        Assert.assertEquals(msgesperada,statusatual);
    }


    // Teste 02 - Adicionar Produto Acabado para Produção
   @Test
   public void AdicionarProdutoAcabado() throws InterruptedException {
        //Objects Instances
       mainPage = new MainPage();

       loginFlows = new LoginFlows();
       mainFlows = new MainFlows();
       geracaodeprodutoacabadopage = new GeracaodeProdutoAcabadoPage();


        // Parameters codigo =

       String usuario = "francielly.automacao";
       String senha = "Teknisa2022";
       String datadeconsumo = "03/08/2022";
       String msgesperada = "Processo realizado com sucesso!";

       loginFlows.efetuarLogin(usuario,senha);
       geracaodeprodutoacabadopage.AcessarTela();

        // Teste
        geracaodeprodutoacabadopage.selecionarplanejamento();
        geracaodeprodutoacabadopage.AdicionarFiltro(datadeconsumo);
        geracaodeprodutoacabadopage.Adicionarprodutoacabado();
        geracaodeprodutoacabadopage.Excluiritenincluso();
        geracaodeprodutoacabadopage.gerarplanejamento();

       String statusatual = geracaodeprodutoacabadopage.geracaoprodutoacabadoconcluida();
       Assert.assertEquals(msgesperada,statusatual);
    }

    // Teste 03 - Adicionar Insumos, Quantidade Extra ou Perda, Geração Parcial e Informando Consumo por Unidade
    @Test
    public void AdicionarQuantidadeExtraePerda() throws InterruptedException {
        //Objects Instances
        mainPage = new MainPage();

        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        geracaodeprodutoacabadopage = new GeracaodeProdutoAcabadoPage();


        // Parameters codigo =

        String usuario = "francielly.automacao";
        String senha = "Teknisa2022";
        String quantextra = "0,00100";
        String quantperda = "0,00099";
        String msgesperada = "Processo realizado com sucesso!";

        loginFlows.efetuarLogin(usuario,senha);
        geracaodeprodutoacabadopage.AcessarTela();

        // Teste
        geracaodeprodutoacabadopage.selecionarplanejamento();
        geracaodeprodutoacabadopage.Adicionarprodutoacabado();
        geracaodeprodutoacabadopage.AdicionarQuantidadeExtraouPerda(quantextra, quantperda);
        geracaodeprodutoacabadopage.GeraçaoParcial();
        geracaodeprodutoacabadopage.ConsumoporUnidadeAgregada();
        geracaodeprodutoacabadopage.gerarplanejamento();

        String statusatual = geracaodeprodutoacabadopage.geracaoprodutoacabadoconcluida();
        Assert.assertEquals(msgesperada,statusatual);
    }

}


